# Go语言高级编程 (Advanced Go Programming)

- *Go语言QQ群: 102319854, 1055927514*
- *光谷码农课堂: https://study.163.com/provider/480000001914454/index.htm*
- *凹语言(凹读音“Wa”)(The Wa Programming Language): https://github.com/wa-lang/wa*

----

**蚂蚁金服招聘云原生方向和编程语言方向岗位(杭州/P7)：云原生方向要求熟悉k8s配套工具，如kubectl、kustomize、kubebuilder，operator；编程语言方向要求对语言对语言解释器（如py/js/lua/wasm等）、工具链、配套SDK有一定兴趣和实践经验。欢迎各位同学咨询或推荐（推荐成功独享全额推荐红包）。联系方式 chaishushan@gmail.com, shushan.css@alibaba-inc.com**

----

两位作者的公众号：

<table>
<tr>
<td>
<img width="222px"  src="https://github.com/chai2010/advanced-go-programming-book/raw/master/css.png">
</td>
<td>
<img width="222px"  src="https://github.com/chai2010/advanced-go-programming-book/raw/master/cch.png">
</td>
</tr>
</table>

----



本书涵盖CGO、Go汇编语言、RPC实现、Web框架实现、分布式系统等高阶主题，针对Go语言有一定经验想深入了解Go语言各种高级用法的开发人员。对于刚学习Go语言的读者，建议先从[《Go语言圣经》](https://github.com/golang-china/gopl-zh)开始系统学习Go语言的基础知识。如果希望深入学习Go语言语法树结构，可以参考[《Go语法树入门——开启自制编程语言和编译器之旅》](https://github.com/chai2010/go-ast-book)。如果希望了解Go2的最新动向，可以参考[《Go2编程指南》](https://github.com/chai2010/go2-book)。

![](cover-20190714.jpg)

- 作者：柴树杉，Github [@chai2010](https://github.com/chai2010)，Twitter [@chaishushan](https://twitter.com/chaishushan)，主页 https://chai2010.cn/about
- 作者：曹春晖，Github [@cch123](https://github.com/cch123)，主页 [xargin](http://xargin.com)
- 网址：https://github.com/chai2010/advanced-go-programming-book
- Star历史：https://starcharts.herokuapp.com/chai2010/advanced-go-programming-book.svg

## 购买链接：

- 京东：https://item.jd.com/12647494.html
- 异步：https://www.epubit.com/book/detail/40090
- 当当：http://product.dangdang.com/27896588.html

如果你喜欢本书，欢迎到豆瓣评论：

[![](douban.png)](https://book.douban.com/subject/34442131/)

- https://book.douban.com/subject/34442131/

<!--

## 抄袭&侵权

- [千锋教育原文抄袭《Go语言高级编程》](https://mp.weixin.qq.com/s/0Jtx79ZSgKY8bBdEvl-PlQ) 证据截图：[01.pdf](chaoxi/zhihu-qianfeng-01.pdf), [02.pdf](chaoxi/zhihu-qianfeng-02.pdf)

-->

## 在线阅读

- [SUMMARY.md](SUMMARY.md)
- https://chai2010.cn/advanced-go-programming-book/
- https://www.gitbook.com/book/chai2010/advanced-go-programming-book/

## 相关文章

1. [GopherChina 2019大会推荐书单来啦](https://zhuanlan.zhihu.com/p/63910336)
1. [深入Go的底层，带你走近一群有追求的人](https://mp.weixin.qq.com/s/obnnVkO2EiFnuXk_AIDHWw)


## 相关报告

1. [Go语言简介](https://talks.godoc.org/github.com/chai2010/awesome-go-zh/chai2010/chai2010-golang-intro.slide) - [chai2010](https://github.com/chai2010/awesome-go-zh/tree/master/chai2010) 武汉·黄鹤会 2018/12/16
1. [GIAC: 2018 - Go 语言将要走向何方？](https://github.com/chai2010/awesome-go-zh/blob/master/chai2010/giac2018) - [chai2010](https://github.com/chai2010/awesome-go-zh/tree/master/chai2010) 上海·GIAC全球互联网架构大会 2018/11/23
1. [Go语言并发编程](https://talks.godoc.org/github.com/chai2010/awesome-go-zh/chai2010/chai2010-golang-concurrency.slide) - [chai2010](https://github.com/chai2010/awesome-go-zh/tree/master/chai2010) 武汉·光谷猫友会 2018/09/16, [整理01](https://mp.weixin.qq.com/s/UaY9gJU85dq-dXlOhLYY1Q)/[整理02](https://mp.weixin.qq.com/s/_aKNO-H11GEDA-l0rycfQQ)
1. 深入CGO编程: https://github.com/chai2010/gopherchina2018-cgo-talk


## 版权声明

<a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://i.creativecommons.org/l/by-nc-nd/4.0/88x31.png" /></a><br /><span xmlns:dct="http://purl.org/dc/terms/" property="dct:title">Go语言高级编程</span> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="https://github.com/chai2010/advanced-go-programming-book" property="cc:attributionName" rel="cc:attributionURL">柴树杉，曹春晖</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/">知识共享 署名-非商业性使用-禁止演绎 4.0 国际 许可协议</a>进行许可。

严禁任何商业行为使用或引用该文档的全部或部分内容！

欢迎大家提供建议！

----

## 鸣谢

感谢大家提供 PR！以下排名不分先后：

<!--
1. get contributors.json
https://api.github.com/repos/chai2010/advanced-go-programming-book/contributors

2. go run gen_contributors.go
3. replace contributors table
-->

| [<img src="https://avatars3.githubusercontent.com/u/15542874?v=4" width="100px;"/><br /><sub><b>fuwensun</b></sub>](https://github.com/fuwensun) | [<img src="https://avatars0.githubusercontent.com/u/1927478?v=4" width="100px;"/><br /><sub><b>qichengzx</b></sub>](https://github.com/qichengzx) | [<img src="https://avatars0.githubusercontent.com/u/914267?v=4" width="100px;"/><br /><sub><b>lewgun</b></sub>](https://github.com/lewgun) | [<img src="https://avatars1.githubusercontent.com/u/26503046?v=4" width="100px;"/><br /><sub><b>LaoK996</b></sub>](https://github.com/LaoK996) | [<img src="https://avatars3.githubusercontent.com/u/15144321?v=4" width="100px;"/><br /><sub><b>plpan</b></sub>](https://github.com/plpan) | [<img src="https://avatars3.githubusercontent.com/u/7970646?v=4" width="100px;"/><br /><sub><b>xiaoliwang</b></sub>](https://github.com/xiaoliwang) | [<img src="https://avatars0.githubusercontent.com/u/16658738?v=4" width="100px;"/><br /><sub><b>barryz</b></sub>](https://github.com/barryz) |
| :---: | :---: | :---: | :---: | :---: | :---: | :---: |
| [<img src="https://avatars3.githubusercontent.com/u/19967175?v=4" width="100px;"/><br /><sub><b>alphayan</b></sub>](https://github.com/alphayan) | [<img src="https://avatars1.githubusercontent.com/u/10794816?v=4" width="100px;"/><br /><sub><b>leobuzhi</b></sub>](https://github.com/leobuzhi) | [<img src="https://avatars2.githubusercontent.com/u/19154488?v=4" width="100px;"/><br /><sub><b>iikira</b></sub>](https://github.com/iikira) | [<img src="https://avatars0.githubusercontent.com/u/26301186?v=4" width="100px;"/><br /><sub><b>fognome</b></sub>](https://github.com/fognome) | [<img src="https://avatars2.githubusercontent.com/u/12817?v=4" width="100px;"/><br /><sub><b>darren</b></sub>](https://github.com/darren) | [<img src="https://avatars3.githubusercontent.com/u/6910037?v=4" width="100px;"/><br /><sub><b>jiayx</b></sub>](https://github.com/jiayx) | [<img src="https://avatars1.githubusercontent.com/u/2696746?v=4" width="100px;"/><br /><sub><b>orangle</b></sub>](https://github.com/orangle) |
| [<img src="https://avatars0.githubusercontent.com/u/9821034?v=4" width="100px;"/><br /><sub><b>yangtaooo</b></sub>](https://github.com/yangtaooo) | [<img src="https://avatars1.githubusercontent.com/u/1538704?v=4" width="100px;"/><br /><sub><b>bcb51</b></sub>](https://github.com/bcb51) | [<img src="https://avatars3.githubusercontent.com/u/38324300?v=4" width="100px;"/><br /><sub><b>mathrobot</b></sub>](https://github.com/mathrobot) | [<img src="https://avatars3.githubusercontent.com/u/40716445?v=4" width="100px;"/><br /><sub><b>7535</b></sub>](https://github.com/7535) | [<img src="https://avatars1.githubusercontent.com/u/1229983?v=4" width="100px;"/><br /><sub><b>cloverstd</b></sub>](https://github.com/cloverstd) | [<img src="https://avatars2.githubusercontent.com/u/1488134?v=4" width="100px;"/><br /><sub><b>douglarek</b></sub>](https://github.com/douglarek) | [<img src="https://avatars0.githubusercontent.com/u/6734408?v=4" width="100px;"/><br /><sub><b>RealDeanZhao</b></sub>](https://github.com/RealDeanZhao) |
| [<img src="https://avatars2.githubusercontent.com/u/8447684?v=4" width="100px;"/><br /><sub><b>yyt030</b></sub>](https://github.com/yyt030) | [<img src="https://avatars3.githubusercontent.com/u/2748184?v=4" width="100px;"/><br /><sub><b>yuqaf1989</b></sub>](https://github.com/yuqaf1989) | [<img src="https://avatars0.githubusercontent.com/u/21311269?v=4" width="100px;"/><br /><sub><b>BeccaBecca</b></sub>](https://github.com/BeccaBecca) | [<img src="https://avatars3.githubusercontent.com/u/152362?v=4" width="100px;"/><br /><sub><b>cloudzhou</b></sub>](https://github.com/cloudzhou) | [<img src="https://avatars1.githubusercontent.com/u/631411?v=4" width="100px;"/><br /><sub><b>ezioruan</b></sub>](https://github.com/ezioruan) | [<img src="https://avatars1.githubusercontent.com/u/16048119?v=4" width="100px;"/><br /><sub><b>hacknode</b></sub>](https://github.com/hacknode) | [<img src="https://avatars1.githubusercontent.com/u/8757196?v=4" width="100px;"/><br /><sub><b>Frozen-Shadow</b></sub>](https://github.com/Frozen-Shadow) |

----

https://api.github.com/repos/chai2010/advanced-go-programming-book/contributors
